/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */ 
request.headers.out."Content-Type"="text/html"

if (config.runtime.mode[] != 'development') {
	request.view = 'DefaultError.gt'
} else {
	msg = request.error.message[]
	exception = request.error.exception[]
	if (exception != null && exception.getCause() != null) {

		if (exception.getCause().getClass().toString().indexOf("org.codehaus.groovy.control.MultipleCompilationErrorsException") != -1) {
		    compileError = exception.getCause().getErrorCollector();
		    if (compileError.hasErrors()) {
		    	Map errorColumns = new HashMap();
		    	Map errorMessages = new HashMap();
		    	int counter = 0;
		    	for ( gerror in compileError.getErrors()) {
		    		counter++;
		    		if (gerror instanceof org.codehaus.groovy.control.messages.SyntaxErrorMessage) {
			        	errorColumns.put(gerror.getCause().getStartLine(), gerror.getCause().getStartColumn());
			        	errorMessages.put(gerror.getCause().getStartLine(), gerror.getCause().getMessage());
		    		} else if (gerror instanceof org.codehaus.groovy.control.messages.SimpleMessage) {
		    			errorMessages.put("Error " + counter,gerror.getMessage());
		    		} else {
		    			errorMessages.put("Error " + counter,"Unknown error type: " + gerror);
		    		}
		    	}
		    
		    	if (errorColumns.size() > 0) {
			    	error1 = compileError.getSyntaxError(0);
			    	request.groovyErrorSourceLocator = error1.getSourceLocator();
			    	request.groovyErrorCount = compileError.getErrorCount();
			    	request.groovyErrorsColumns = errorColumns;
		    	}
		    
	    		request.groovyErrorsMessages = errorMessages
		    	request.view = 'GroovySourceCodeViewer.gt'
		    	render()

		    	return
	    	}
		}
	}
	request.view = 'DevelopmentDefaultError.gt'
}

render()